// Generated by dts-bundle v0.7.3-fork.1
// Dependencies for this module:
//   ../../../../../@fullcalendar/core

declare module '@fullcalendar/timeline' {
    import TimelineView from '@fullcalendar/timeline/TimelineView';
    
    export { TimelineView };
    export { buildSlatCols } from '@fullcalendar/timeline/TimelineView';
    export { default as TimelineLane, TimelineLaneProps, TimelineLaneCoreProps } from '@fullcalendar/timeline/TimelineLane';
    export { default as TimelineLaneBg } from '@fullcalendar/timeline/TimelineLaneBg';
    export { default as TimelineHeader } from '@fullcalendar/timeline/TimelineHeader';
    export { default as TimelineSlats } from '@fullcalendar/timeline/TimelineSlats';
    export { TimelineDateProfile, buildTimelineDateProfile } from '@fullcalendar/timeline/timeline-date-profile';
    export { default as TimelineCoords } from '@fullcalendar/timeline/TimelineCoords';
    export { default as TimelineLaneSlicer, TimelineLaneSeg } from '@fullcalendar/timeline/TimelineLaneSlicer';
    export { default as TimelineHeaderRows } from '@fullcalendar/timeline/TimelineHeaderRows';
    const _default: import("@fullcalendar/core").PluginDef;
    export default _default;
}

declare module '@fullcalendar/timeline/TimelineView' {
    import { h, ViewProps, ComponentContext, DateComponent } from '@fullcalendar/core';
    import { TimelineDateProfile } from '@fullcalendar/timeline/timeline-date-profile';
    import TimelineCoords from '@fullcalendar/timeline/TimelineCoords';
    interface TimelineViewState {
        slatCoords?: TimelineCoords;
        slotCushionMaxWidth?: number;
    }
    export { TimelineView as default, TimelineView };
    class TimelineView extends DateComponent<ViewProps, TimelineViewState> {
        render(props: ViewProps, state: TimelineViewState, context: ComponentContext): h.JSX.Element;
        handleSlatCoords: (slatCoords: TimelineCoords) => void;
        handleScrollLeftRequest: (scrollLeft: number) => void;
        handleMaxCushionWidth: (slotCushionMaxWidth: any) => void;
        computeFallbackSlotMinWidth(tDateProfile: TimelineDateProfile): number;
    }
    export function buildSlatCols(tDateProfile: TimelineDateProfile, slotMinWidth?: number): {
        span: number;
        minWidth: number;
    }[];
    export {};
}

declare module '@fullcalendar/timeline/TimelineLane' {
    import { Duration, EventStore, EventUiHash, DateSpan, EventInteractionState, ComponentContext, DateProfile, DateProfileGenerator, BaseComponent, h, DateMarker, DateRange } from '@fullcalendar/core';
    import { TimelineDateProfile } from '@fullcalendar/timeline/timeline-date-profile';
    import TimelineCoords from '@fullcalendar/timeline/TimelineCoords';
    import { TimelineLaneSeg } from '@fullcalendar/timeline/TimelineLaneSlicer';
    import { TimelineSegDims } from '@fullcalendar/timeline/event-placement';
    export interface TimelineLaneProps extends TimelineLaneCoreProps {
        onHeightChange?: (isStable: boolean) => void;
    }
    export interface TimelineLaneCoreProps {
        dateProfile: DateProfile;
        dateProfileGenerator: DateProfileGenerator;
        nowDate: DateMarker;
        todayRange: DateRange;
        tDateProfile: TimelineDateProfile;
        nextDayThreshold: Duration;
        businessHours: EventStore | null;
        eventStore: EventStore | null;
        eventUiBases: EventUiHash;
        dateSelection: DateSpan | null;
        eventSelection: string;
        eventDrag: EventInteractionState | null;
        eventResize: EventInteractionState | null;
        timelineCoords?: TimelineCoords;
    }
    interface TimelineLaneState {
        segDims?: {
            [instanceId: string]: TimelineSegDims;
        };
    }
    export { TimelineLane as default, TimelineLane };
    class TimelineLane extends BaseComponent<TimelineLaneProps, TimelineLaneState> {
        render(props: TimelineLaneProps, state: TimelineLaneState, context: ComponentContext): h.JSX.Element;
        componentDidMount(): void;
        componentDidUpdate(prevProps: TimelineLaneProps, prevState: TimelineLaneState): void;
        updateSize(): void;
        renderFgSegs(segs: TimelineLaneSeg[], segHorizontals: any, segTops: any, hiddenSegs: any, isDragging: any, isResizing: any, isDateSelecting: any): h.JSX.Element;
    }
    export {};
}

declare module '@fullcalendar/timeline/TimelineLaneBg' {
    import { BaseComponent, h, DateRange, DateMarker } from '@fullcalendar/core';
    import TimelineCoords from '@fullcalendar/timeline/TimelineCoords';
    import { TimelineLaneSeg } from '@fullcalendar/timeline/TimelineLaneSlicer';
    export interface TimelineLaneBgProps {
        businessHourSegs: TimelineLaneSeg[] | null;
        bgEventSegs: TimelineLaneSeg[] | null;
        dateSelectionSegs: TimelineLaneSeg[];
        eventResizeSegs: TimelineLaneSeg[];
        timelineCoords?: TimelineCoords;
        todayRange: DateRange;
        nowDate: DateMarker;
    }
    export { TimelineLaneBg as default, TimelineLaneBg };
    class TimelineLaneBg extends BaseComponent<TimelineLaneBgProps> {
        render(props: TimelineLaneBgProps): h.JSX.Element;
        renderSegs(segs: TimelineLaneSeg[], timelineCoords: TimelineCoords, fillType: string): h.JSX.Element[];
    }
}

declare module '@fullcalendar/timeline/TimelineHeader' {
    import { h, BaseComponent, CssDimValue, VNode, ComponentContext, DateProfile, RefObject } from '@fullcalendar/core';
    import TimelineCoords from '@fullcalendar/timeline/TimelineCoords';
    import { TimelineDateProfile } from '@fullcalendar/timeline/timeline-date-profile';
    export interface TimelineHeaderProps {
        dateProfile: DateProfile;
        tDateProfile: TimelineDateProfile;
        clientWidth: number | null;
        clientHeight: number | null;
        tableMinWidth: CssDimValue;
        tableColGroupNode: VNode;
        slatCoords: TimelineCoords;
        rowInnerHeights?: number[];
        onMaxCushionWidth?: (number: any) => void;
    }
    export { TimelineHeader as default, TimelineHeader };
    class TimelineHeader extends BaseComponent<TimelineHeaderProps> {
        rootElRef: RefObject<HTMLDivElement>;
        render(props: TimelineHeaderProps, state: {}, context: ComponentContext): h.JSX.Element;
        componentDidMount(): void;
        componentDidUpdate(): void;
        updateSize(): void;
        computeMaxCushionWidth(): number;
    }
}

declare module '@fullcalendar/timeline/TimelineSlats' {
    import { h, BaseComponent, DateProfile, ComponentContext, CssDimValue, VNode, ScrollRequest, DateMarker, DateRange } from '@fullcalendar/core';
    import { TimelineDateProfile } from '@fullcalendar/timeline/timeline-date-profile';
    import TimelineCoords from '@fullcalendar/timeline/TimelineCoords';
    export interface TimelineSlatsProps extends TimelineSlatsContentProps {
        clientWidth: number | null;
        tableMinWidth: CssDimValue;
        tableColGroupNode: VNode;
        onCoords?: (coord: TimelineCoords | null) => void;
        onScrollLeftRequest?: (scrollLeft: number) => void;
    }
    interface TimelineSlatsContentProps {
        dateProfile: DateProfile;
        tDateProfile: TimelineDateProfile;
        nowDate: DateMarker;
        todayRange: DateRange;
    }
    export { TimelineSlats as default, TimelineSlats };
    class TimelineSlats extends BaseComponent<TimelineSlatsProps> {
        render(props: TimelineSlatsProps, state: {}, context: ComponentContext): h.JSX.Element;
        componentDidMount(): void;
        componentDidUpdate(prevProps: TimelineSlatsProps): void;
        componentWillUnmount(): void;
        updateSizing(): void;
        handleScrollRequest: (request: ScrollRequest) => boolean;
        positionToHit(leftPosition: any): {
            dateSpan: {
                range: {
                    start: Date;
                    end: Date;
                };
                allDay: boolean;
            };
            dayEl: HTMLTableCellElement;
            left: any;
            right: any;
        };
    }
    export {};
}

declare module '@fullcalendar/timeline/timeline-date-profile' {
    import { Duration, DateProfile, DateMarker, DateEnv, DateRange, DateProfileGenerator } from '@fullcalendar/core';
    export interface TimelineDateProfile {
        labelInterval: Duration;
        slotDuration: Duration;
        slotsPerLabel: number;
        headerFormats: any;
        isTimeScale: boolean;
        largeUnit: string;
        emphasizeWeeks: boolean;
        snapDuration: Duration;
        snapsPerSlot: number;
        normalizedRange: DateRange;
        timeWindowMs: number;
        slotDates: DateMarker[];
        isWeekStarts: boolean[];
        snapDiffToIndex: number[];
        snapIndexToDiff: number[];
        snapCnt: number;
        slotCnt: number;
        cellRows: TimelineHeaderCell[][];
    }
    export interface TimelineHeaderCell {
        date: DateMarker;
        text: string;
        rowUnit: string;
        colspan: number;
        isWeekStart: boolean;
    }
    export function buildTimelineDateProfile(dateProfile: DateProfile, dateEnv: DateEnv, allOptions: any, dateProfileGenerator: DateProfileGenerator): TimelineDateProfile;
    export function normalizeDate(date: DateMarker, tDateProfile: TimelineDateProfile, dateEnv: DateEnv): DateMarker;
    export function normalizeRange(range: DateRange, tDateProfile: TimelineDateProfile, dateEnv: DateEnv): DateRange;
    export function isValidDate(date: DateMarker, tDateProfile: TimelineDateProfile, dateProfile: DateProfile, dateProfileGenerator: DateProfileGenerator): boolean;
}

declare module '@fullcalendar/timeline/TimelineCoords' {
    import { PositionCache, DateProfile, DateMarker, DateEnv, Duration } from '@fullcalendar/core';
    import { TimelineDateProfile } from '@fullcalendar/timeline/timeline-date-profile';
    export { TimelineCoords as default, TimelineCoords };
    class TimelineCoords {
        slatRootEl: HTMLElement;
        isRtl: boolean;
        outerCoordCache: PositionCache;
        innerCoordCache: PositionCache;
        constructor(slatRootEl: HTMLElement, // okay to expose?
        slatEls: HTMLElement[], dateProfile: DateProfile, tDateProfile: TimelineDateProfile, dateEnv: DateEnv, isRtl: boolean);
        rangeToCoords(range: any): {
            right: any;
            left: any;
        };
        isDateInRange(date: DateMarker): boolean;
        dateToCoord(date: any): any;
        computeDateSnapCoverage(date: DateMarker): number;
        computeDurationLeft(duration: Duration): number;
    }
    export function computeDateSnapCoverage(date: DateMarker, tDateProfile: TimelineDateProfile, dateEnv: DateEnv): number;
}

declare module '@fullcalendar/timeline/TimelineLaneSlicer' {
    import { DateRange, DateProfile, Slicer, DateProfileGenerator, DateEnv, DateMarker, Seg } from '@fullcalendar/core';
    import { TimelineDateProfile } from '@fullcalendar/timeline/timeline-date-profile';
    export interface TimelineLaneSeg extends Seg {
        start: DateMarker;
        end: DateMarker;
    }
    export { TimelineLaneSlicer as default, TimelineLaneSlicer };
    class TimelineLaneSlicer extends Slicer<TimelineLaneSeg, [DateProfile, DateProfileGenerator, TimelineDateProfile, DateEnv]> {
        sliceRange(origRange: DateRange, dateProfile: DateProfile, dateProfileGenerator: DateProfileGenerator, tDateProfile: TimelineDateProfile, dateEnv: DateEnv): TimelineLaneSeg[];
    }
}

declare module '@fullcalendar/timeline/TimelineHeaderRows' {
    import { h, BaseComponent, ComponentContext, DateProfile, DateRange, DateMarker } from '@fullcalendar/core';
    import { TimelineDateProfile } from '@fullcalendar/timeline/timeline-date-profile';
    export interface TimelineHeaderRowsProps {
        dateProfile: DateProfile;
        tDateProfile: TimelineDateProfile;
        nowDate: DateMarker;
        todayRange: DateRange;
        rowInnerHeights?: number[];
    }
    export { TimelineHeaderRows as default, TimelineHeaderRows };
    class TimelineHeaderRows extends BaseComponent<TimelineHeaderRowsProps> {
        render(props: TimelineHeaderRowsProps, state: {}, context: ComponentContext): h.JSX.Element;
    }
}

declare module '@fullcalendar/timeline/event-placement' {
    import TimelineCoords from '@fullcalendar/timeline/TimelineCoords';
    import { TimelineLaneSeg } from '@fullcalendar/timeline/TimelineLaneSlicer';
    export function computeSegHorizontals(segs: TimelineLaneSeg[], timelineCoords?: TimelineCoords): {
        [instanceId: string]: {
            left: number;
            right: number;
        };
    };
    export interface TimelineSegDims {
        left: number;
        right: number;
        height: number;
    }
    export function computeSegVerticals(segs: TimelineLaneSeg[], eventOrderSpecs: any, dimHash: {
        [key: string]: TimelineSegDims;
    } | null): {
        segTops: {
            [key: string]: number;
        };
        height: number;
    };
}

